void ui_client_event_mode_info_set(Array args)
{
  if (args.size < 2
      || args.items[0].type != kObjectTypeBoolean
      || args.items[1].type != kObjectTypeArray) {
    ELOG("Error handling ui event 'mode_info_set'");
    return;
  }
  Boolean arg_1 = args.items[0].data.boolean;
  Array arg_2 = args.items[1].data.array;
  ui_call_mode_info_set(arg_1, arg_2);
}

void ui_client_event_update_menu(Array args)
{
  ui_call_update_menu();
}

void ui_client_event_busy_start(Array args)
{
  ui_call_busy_start();
}

void ui_client_event_busy_stop(Array args)
{
  ui_call_busy_stop();
}

void ui_client_event_mouse_on(Array args)
{
  ui_call_mouse_on();
}

void ui_client_event_mouse_off(Array args)
{
  ui_call_mouse_off();
}

void ui_client_event_mode_change(Array args)
{
  if (args.size < 2
      || args.items[0].type != kObjectTypeString
      || args.items[1].type != kObjectTypeInteger) {
    ELOG("Error handling ui event 'mode_change'");
    return;
  }
  String arg_1 = args.items[0].data.string;
  Integer arg_2 = args.items[1].data.integer;
  ui_call_mode_change(arg_1, arg_2);
}

void ui_client_event_bell(Array args)
{
  ui_call_bell();
}

void ui_client_event_visual_bell(Array args)
{
  ui_call_visual_bell();
}

void ui_client_event_flush(Array args)
{
  ui_call_flush();
}

void ui_client_event_suspend(Array args)
{
  ui_call_suspend();
}

void ui_client_event_set_title(Array args)
{
  if (args.size < 1
      || args.items[0].type != kObjectTypeString) {
    ELOG("Error handling ui event 'set_title'");
    return;
  }
  String arg_1 = args.items[0].data.string;
  ui_call_set_title(arg_1);
}

void ui_client_event_set_icon(Array args)
{
  if (args.size < 1
      || args.items[0].type != kObjectTypeString) {
    ELOG("Error handling ui event 'set_icon'");
    return;
  }
  String arg_1 = args.items[0].data.string;
  ui_call_set_icon(arg_1);
}

void ui_client_event_screenshot(Array args)
{
  if (args.size < 1
      || args.items[0].type != kObjectTypeString) {
    ELOG("Error handling ui event 'screenshot'");
    return;
  }
  String arg_1 = args.items[0].data.string;
  ui_call_screenshot(arg_1);
}

void ui_client_event_option_set(Array args)
{
  if (args.size < 2
      || args.items[0].type != kObjectTypeString) {
    ELOG("Error handling ui event 'option_set'");
    return;
  }
  String arg_1 = args.items[0].data.string;
  Object arg_2 = args.items[1];
  ui_call_option_set(arg_1, arg_2);
}

void ui_client_event_default_colors_set(Array args)
{
  if (args.size < 5
      || args.items[0].type != kObjectTypeInteger
      || args.items[1].type != kObjectTypeInteger
      || args.items[2].type != kObjectTypeInteger
      || args.items[3].type != kObjectTypeInteger
      || args.items[4].type != kObjectTypeInteger) {
    ELOG("Error handling ui event 'default_colors_set'");
    return;
  }
  Integer arg_1 = args.items[0].data.integer;
  Integer arg_2 = args.items[1].data.integer;
  Integer arg_3 = args.items[2].data.integer;
  Integer arg_4 = args.items[3].data.integer;
  Integer arg_5 = args.items[4].data.integer;
  ui_call_default_colors_set(arg_1, arg_2, arg_3, arg_4, arg_5);
}

void ui_client_event_hl_attr_define(Array args)
{
  if (args.size < 4
      || args.items[0].type != kObjectTypeInteger
      || args.items[1].type != kObjectTypeDictionary
      || args.items[2].type != kObjectTypeDictionary
      || args.items[3].type != kObjectTypeArray) {
    ELOG("Error handling ui event 'hl_attr_define'");
    return;
  }
  Integer arg_1 = args.items[0].data.integer;
  HlAttrs arg_2 = ui_client_dict2hlattrs(args.items[1].data.dictionary, true);
  HlAttrs arg_3 = ui_client_dict2hlattrs(args.items[2].data.dictionary, false);
  Array arg_4 = args.items[3].data.array;
  ui_call_hl_attr_define(arg_1, arg_2, arg_3, arg_4);
}

void ui_client_event_hl_group_set(Array args)
{
  if (args.size < 2
      || args.items[0].type != kObjectTypeString
      || args.items[1].type != kObjectTypeInteger) {
    ELOG("Error handling ui event 'hl_group_set'");
    return;
  }
  String arg_1 = args.items[0].data.string;
  Integer arg_2 = args.items[1].data.integer;
  ui_call_hl_group_set(arg_1, arg_2);
}

void ui_client_event_grid_clear(Array args)
{
  if (args.size < 1
      || args.items[0].type != kObjectTypeInteger) {
    ELOG("Error handling ui event 'grid_clear'");
    return;
  }
  Integer arg_1 = args.items[0].data.integer;
  ui_call_grid_clear(arg_1);
}

void ui_client_event_grid_cursor_goto(Array args)
{
  if (args.size < 3
      || args.items[0].type != kObjectTypeInteger
      || args.items[1].type != kObjectTypeInteger
      || args.items[2].type != kObjectTypeInteger) {
    ELOG("Error handling ui event 'grid_cursor_goto'");
    return;
  }
  Integer arg_1 = args.items[0].data.integer;
  Integer arg_2 = args.items[1].data.integer;
  Integer arg_3 = args.items[2].data.integer;
  ui_call_grid_cursor_goto(arg_1, arg_2, arg_3);
}

void ui_client_event_grid_scroll(Array args)
{
  if (args.size < 7
      || args.items[0].type != kObjectTypeInteger
      || args.items[1].type != kObjectTypeInteger
      || args.items[2].type != kObjectTypeInteger
      || args.items[3].type != kObjectTypeInteger
      || args.items[4].type != kObjectTypeInteger
      || args.items[5].type != kObjectTypeInteger
      || args.items[6].type != kObjectTypeInteger) {
    ELOG("Error handling ui event 'grid_scroll'");
    return;
  }
  Integer arg_1 = args.items[0].data.integer;
  Integer arg_2 = args.items[1].data.integer;
  Integer arg_3 = args.items[2].data.integer;
  Integer arg_4 = args.items[3].data.integer;
  Integer arg_5 = args.items[4].data.integer;
  Integer arg_6 = args.items[5].data.integer;
  Integer arg_7 = args.items[6].data.integer;
  ui_call_grid_scroll(arg_1, arg_2, arg_3, arg_4, arg_5, arg_6, arg_7);
}

void ui_client_event_msg_set_pos(Array args)
{
  if (args.size < 4
      || args.items[0].type != kObjectTypeInteger
      || args.items[1].type != kObjectTypeInteger
      || args.items[2].type != kObjectTypeBoolean
      || args.items[3].type != kObjectTypeString) {
    ELOG("Error handling ui event 'msg_set_pos'");
    return;
  }
  Integer arg_1 = args.items[0].data.integer;
  Integer arg_2 = args.items[1].data.integer;
  Boolean arg_3 = args.items[2].data.boolean;
  String arg_4 = args.items[3].data.string;
  ui_call_msg_set_pos(arg_1, arg_2, arg_3, arg_4);
}

void ui_client_event_wildmenu_show(Array args)
{
  if (args.size < 1
      || args.items[0].type != kObjectTypeArray) {
    ELOG("Error handling ui event 'wildmenu_show'");
    return;
  }
  Array arg_1 = args.items[0].data.array;
  ui_call_wildmenu_show(arg_1);
}

void ui_client_event_wildmenu_select(Array args)
{
  if (args.size < 1
      || args.items[0].type != kObjectTypeInteger) {
    ELOG("Error handling ui event 'wildmenu_select'");
    return;
  }
  Integer arg_1 = args.items[0].data.integer;
  ui_call_wildmenu_select(arg_1);
}

void ui_client_event_wildmenu_hide(Array args)
{
  ui_call_wildmenu_hide();
}

void ui_client_methods_table_init(void)
{

  add_ui_client_event_handler((String) {.data = "mode_info_set", .size = sizeof("mode_info_set") - 1}, (UIClientHandler) ui_client_event_mode_info_set);
  add_ui_client_event_handler((String) {.data = "update_menu", .size = sizeof("update_menu") - 1}, (UIClientHandler) ui_client_event_update_menu);
  add_ui_client_event_handler((String) {.data = "busy_start", .size = sizeof("busy_start") - 1}, (UIClientHandler) ui_client_event_busy_start);
  add_ui_client_event_handler((String) {.data = "busy_stop", .size = sizeof("busy_stop") - 1}, (UIClientHandler) ui_client_event_busy_stop);
  add_ui_client_event_handler((String) {.data = "mouse_on", .size = sizeof("mouse_on") - 1}, (UIClientHandler) ui_client_event_mouse_on);
  add_ui_client_event_handler((String) {.data = "mouse_off", .size = sizeof("mouse_off") - 1}, (UIClientHandler) ui_client_event_mouse_off);
  add_ui_client_event_handler((String) {.data = "mode_change", .size = sizeof("mode_change") - 1}, (UIClientHandler) ui_client_event_mode_change);
  add_ui_client_event_handler((String) {.data = "bell", .size = sizeof("bell") - 1}, (UIClientHandler) ui_client_event_bell);
  add_ui_client_event_handler((String) {.data = "visual_bell", .size = sizeof("visual_bell") - 1}, (UIClientHandler) ui_client_event_visual_bell);
  add_ui_client_event_handler((String) {.data = "flush", .size = sizeof("flush") - 1}, (UIClientHandler) ui_client_event_flush);
  add_ui_client_event_handler((String) {.data = "suspend", .size = sizeof("suspend") - 1}, (UIClientHandler) ui_client_event_suspend);
  add_ui_client_event_handler((String) {.data = "set_title", .size = sizeof("set_title") - 1}, (UIClientHandler) ui_client_event_set_title);
  add_ui_client_event_handler((String) {.data = "set_icon", .size = sizeof("set_icon") - 1}, (UIClientHandler) ui_client_event_set_icon);
  add_ui_client_event_handler((String) {.data = "screenshot", .size = sizeof("screenshot") - 1}, (UIClientHandler) ui_client_event_screenshot);
  add_ui_client_event_handler((String) {.data = "option_set", .size = sizeof("option_set") - 1}, (UIClientHandler) ui_client_event_option_set);
  add_ui_client_event_handler((String) {.data = "default_colors_set", .size = sizeof("default_colors_set") - 1}, (UIClientHandler) ui_client_event_default_colors_set);
  add_ui_client_event_handler((String) {.data = "hl_attr_define", .size = sizeof("hl_attr_define") - 1}, (UIClientHandler) ui_client_event_hl_attr_define);
  add_ui_client_event_handler((String) {.data = "hl_group_set", .size = sizeof("hl_group_set") - 1}, (UIClientHandler) ui_client_event_hl_group_set);
  add_ui_client_event_handler((String) {.data = "grid_resize", .size = sizeof("grid_resize") - 1}, (UIClientHandler) ui_client_event_grid_resize);
  add_ui_client_event_handler((String) {.data = "grid_clear", .size = sizeof("grid_clear") - 1}, (UIClientHandler) ui_client_event_grid_clear);
  add_ui_client_event_handler((String) {.data = "grid_cursor_goto", .size = sizeof("grid_cursor_goto") - 1}, (UIClientHandler) ui_client_event_grid_cursor_goto);
  add_ui_client_event_handler((String) {.data = "grid_line", .size = sizeof("grid_line") - 1}, (UIClientHandler) ui_client_event_grid_line);
  add_ui_client_event_handler((String) {.data = "grid_scroll", .size = sizeof("grid_scroll") - 1}, (UIClientHandler) ui_client_event_grid_scroll);
  add_ui_client_event_handler((String) {.data = "msg_set_pos", .size = sizeof("msg_set_pos") - 1}, (UIClientHandler) ui_client_event_msg_set_pos);
  add_ui_client_event_handler((String) {.data = "wildmenu_show", .size = sizeof("wildmenu_show") - 1}, (UIClientHandler) ui_client_event_wildmenu_show);
  add_ui_client_event_handler((String) {.data = "wildmenu_select", .size = sizeof("wildmenu_select") - 1}, (UIClientHandler) ui_client_event_wildmenu_select);
  add_ui_client_event_handler((String) {.data = "wildmenu_hide", .size = sizeof("wildmenu_hide") - 1}, (UIClientHandler) ui_client_event_wildmenu_hide);

}

